package com.loafle.overflow.crawler.wmi;

import java.util.*;



/**
 * Created by root on 17. 4. 12.
 */
public class WMICrawlerLinux extends WMICrawlerOS {

    private final String DELIMITER = "||";
    private final String DELIMITER_SPLIT = "\\|\\|";

    public Object processWMI(Map<String, Object> params) throws Exception {
        return processCommand(params);
    }

    public Object processCommand(Map<String, Object> params) throws Exception {

//        String id = "administrator";
//        String pw = "dbseogns18";
//        String nameSpace = "root/cimv2";
//        String query = "select * from Win32_OperatingSystem";
//        String ip = "192.168.1.106";

        String id = (String)params.get("id");
        String pw = (String)params.get("pw");
        String nameSpace = (String)params.get("nameSpace");
        String query = (String)params.get("query");
        String ip = (String)params.get("ip");

        List<String> argList = new ArrayList<String>();


        argList.add("/home/snoop/temp/wmic");
        argList.add("-U");
        argList.add(id + "%" + pw);
        argList.add("//" + ip);
        argList.add(query);
        argList.add("--namespace=" + nameSpace);
        argList.add("--delimiter=" + DELIMITER);


        return execute(argList.toArray(new String[argList.size()]));
    }

    public Object execute(String... args) throws Exception {
        System.out.println("");
        ProcessBuilder builder = new ProcessBuilder(args);
        Process process = builder.start();

        byte[] msg = new byte[1024];

        StringBuffer buf = new StringBuffer();

        while(process.getInputStream().read(msg) > 0) {
            buf.append(new String(msg));
            Arrays.fill(msg, (byte)0);
        }

        return parseResult(buf.toString());
    }

    public Object parseResult(String result) throws Exception {

        if(result == null || result.length() <= 0) {
            return null;
        }

        result = result.trim();

        List<Map<String,String>> resultMapList = new ArrayList<Map<String, String>>();

        int errIdx = result.indexOf("ERROR:");
        if(errIdx >= 0) {

            int enterIdx = result.indexOf("\\n", errIdx);
            if(enterIdx < 0) enterIdx = result.length();
            String errStr = result.substring(errIdx + "ERROR:".length(), enterIdx);


            Map<String,String> map = new HashMap<>();

            map.put("ERROR", errStr);
            resultMapList.add(map);
            return resultMapList;
        }


        String[] lines = result.split("\\n");
        String line = "";



        List<String> columns = null;
        for (int indexI = 0 ; indexI < lines.length; ++indexI) {

            line = lines[indexI].trim();
            if (line.length() <= 0) continue;
            if(indexI == 0) {
                int idx = line.indexOf("CLASS:");
                if (idx >= 0 ) {
                    continue;
                }
            }

            line = line.trim();

            if (columns == null) {
                String[] datas = line.split(DELIMITER_SPLIT);
                columns = Arrays.asList(datas);
                continue;
            }

            String[] datas = line.split(DELIMITER_SPLIT);
            Map<String, String>  data = new HashMap<String, String>();
            for(int indexJ = 0; indexJ < columns.size(); ++indexJ) {
                data.put(columns.get(indexJ), datas[indexJ]);
            }

            resultMapList.add(data);

        }

        return resultMapList;
    }
}
